/* SPDX-License-Identifier: GPL-2.0 */
#include "../halmac_88xx_cfg.h"
#include "halmac_8822b_cfg.h"

/*
 *  drivers should parse below arrays and do the corresponding actions
 */
/* 3 Power on  Array */
HALMAC_WLAN_PWR_CFG halmac_8822b_power_on_flow[] = {
	HALMAC_RTL8822B_TRANS_CARDEMU_TO_ACT
	HALMAC_RTL8822B_TRANS_END
};

/* 3 Radio off GPIO Array */
HALMAC_WLAN_PWR_CFG halmac_8822b_radio_off_flow[] = {
	HALMAC_RTL8822B_TRANS_ACT_TO_CARDEMU
	HALMAC_RTL8822B_TRANS_END
};

/* 3 Card Disable Array */
HALMAC_WLAN_PWR_CFG halmac_8822b_card_disable_flow[HALMAC_8822B_TRANS_ACT_TO_CARDEMU_STEPS + HALMAC_8822B_TRANS_CARDEMU_TO_PDN_STEPS + HALMAC_8822B_TRANS_END_STEPS] = {
	HALMAC_RTL8822B_TRANS_ACT_TO_CARDEMU
	HALMAC_RTL8822B_TRANS_CARDEMU_TO_CARDDIS
	HALMAC_RTL8822B_TRANS_END
};

/* 3 Card Enable Array */
HALMAC_WLAN_PWR_CFG halmac_8822b_card_enable_flow[HALMAC_8822B_TRANS_ACT_TO_CARDEMU_STEPS + HALMAC_8822B_TRANS_CARDEMU_TO_PDN_STEPS + HALMAC_8822B_TRANS_END_STEPS] = {
	HALMAC_RTL8822B_TRANS_CARDDIS_TO_CARDEMU
	HALMAC_RTL8822B_TRANS_CARDEMU_TO_ACT
	HALMAC_RTL8822B_TRANS_END
};

/* 3 Suspend Array */
HALMAC_WLAN_PWR_CFG halmac_8822b_suspend_flow[HALMAC_8822B_TRANS_ACT_TO_CARDEMU_STEPS + HALMAC_8822B_TRANS_CARDEMU_TO_SUS_STEPS + HALMAC_8822B_TRANS_END_STEPS] = {
	HALMAC_RTL8822B_TRANS_ACT_TO_CARDEMU
	HALMAC_RTL8822B_TRANS_CARDEMU_TO_SUS
	HALMAC_RTL8822B_TRANS_END
};

/* 3 Resume Array */
HALMAC_WLAN_PWR_CFG halmac_8822b_resume_flow[HALMAC_8822B_TRANS_ACT_TO_CARDEMU_STEPS + HALMAC_8822B_TRANS_CARDEMU_TO_SUS_STEPS + HALMAC_8822B_TRANS_END_STEPS] = {
	HALMAC_RTL8822B_TRANS_SUS_TO_CARDEMU
	HALMAC_RTL8822B_TRANS_CARDEMU_TO_ACT
	HALMAC_RTL8822B_TRANS_END
};



/* 3HWPDN Array */
HALMAC_WLAN_PWR_CFG halmac_8822b_hwpdn_flow[HALMAC_8822B_TRANS_ACT_TO_CARDEMU_STEPS + HALMAC_8822B_TRANS_CARDEMU_TO_PDN_STEPS + HALMAC_8822B_TRANS_END_STEPS] = {
	/* TRANS_ACT_TO_CARDEMU */
	/* TRANS_CARDEMU_TO_PDN */
	/* HW behavior */
	HALMAC_RTL8822B_TRANS_END
};

/* 3 Enter LPS */
HALMAC_WLAN_PWR_CFG halmac_8822b_enter_lps_flow[HALMAC_8822B_TRANS_ACT_TO_LPS_STEPS + HALMAC_8822B_TRANS_END_STEPS] = {
	/* FW behavior */
	HALMAC_RTL8822B_TRANS_ACT_TO_LPS
	HALMAC_RTL8822B_TRANS_END
};

/* 3 Enter Deep LPS */
HALMAC_WLAN_PWR_CFG halmac_8822b_enter_deep_lps_flow[HALMAC_8822B_TRANS_ACT_TO_DEEP_LPS_STEPS + HALMAC_8822B_TRANS_END_STEPS] = {
	/* FW behavior */
	HALMAC_RTL8822B_TRANS_ACT_TO_DEEP_LPS
	HALMAC_RTL8822B_TRANS_END
};

/* 3 Leave LPS */
HALMAC_WLAN_PWR_CFG halmac_8822b_leave_lps_flow[HALMAC_8822B_TRANS_LPS_TO_ACT_STEPS + HALMAC_8822B_TRANS_END_STEPS] = {
	/* FW behavior */
	HALMAC_RTL8822B_TRANS_LPS_TO_ACT
	HALMAC_RTL8822B_TRANS_END
};
